## sopt 4.2.0+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13.4) # CMake 3.13.4 is the currently default in Debian 10 repositories

# Do not allow in-source builds.
if(PROJECT_SOURCE_DIR STREQUAL PROJECT_BINARY_DIR)
	message(FATAL_ERROR "In-source builds are not allowed!\nCreate a \"build\" dir and remove:\n- ${CMAKE_SOURCE_DIR}/CMakeCache.txt\n- ${CMAKE_SOURCE_DIR}/CMakeFiles")
endif()

project(sopt
        DESCRIPTION "Sparse OPTimisation using state-of-the-art convex optimisation algorithms."
        HOMEPAGE_URL "http://astro-informatics.github.io/sopt/"
        LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

# https://cmake.org/cmake/help/latest/variable/CMAKE_EXPORT_COMPILE_COMMANDS.html
# Enable output of compile commands during generation. If enabled, generates a compile_commands.json file containing the exact compiler calls for all translation units of the project in machine-readable form. This can be consumed by various IDEs and static analysers to provide smarter project diagnostics/completions etc.
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# https://stackoverflow.com/a/67410042
# Create a symlink to compile_commands.json located in CMAKE_BINARY_DIR to the project root (works across filesystems)
execute_process(
  COMMAND ${CMAKE_COMMAND} -E create_symlink
  ${CMAKE_BINARY_DIR}/compile_commands.json
  ${CMAKE_SOURCE_DIR}/compile_commands.json)

# Location of extra cmake includes for the project
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake_files)
list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/build)

# Version and git hash id
find_package(Git)

# Set version variable
set(SOPT_VERSION 3.1.0)

# If git is found and this is a git workdir, then figure out build id
# Stores results in SOPT_VERSION and SOPT_GITREF
if(GIT_FOUND)
  execute_process(
    COMMAND ${GIT_EXECUTABLE} rev-parse HEAD
    RESULT_VARIABLE HASH_RESULT
    OUTPUT_VARIABLE GIT_HASH
    ERROR_QUIET
  )
  if(HASH_RESULT EQUAL 0)
    string(STRIP "${GIT_HASH}" GIT_HASH)
  else()
    set(GIT_HASH "NA")
  endif()
else()
  set(GIT_HASH "NA")
endif()

set(SOPT_GITREF ${GIT_HASH})


option(tests          "Enable testing"                         on)
option(benchmarks     "Enable benchmarking"                    off)
option(examples       "Enable Examples"                        on)
option(openmp         "Enable OpenMP"                          on)
option(dompi          "Enable MPI"                             on)
option(docs           "Build documentation"                    off)
option(coverage       "Build coverage"                         off)
option(onnxrt         "Enable ONNXruntime interface"           off)

if(NOT CMAKE_BUILD_TYPE)
  message(STATUS "Setting build type to 'Release' as none was specified.")
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING "Build Type" FORCE)
endif()
message(STATUS "Building sopt in ${CMAKE_BUILD_TYPE} mode")

if(tests OR examples)
  enable_testing()
endif()


include(compilations)

# search/install dependencies
include(dependencies)

# sets rpath policy explicitly
if(CMAKE_VERSION VERSION_LESS 3.0)
    set_property(GLOBAL PROPERTY MACOSX_RPATH ON)
else()
    cmake_policy(SET CMP0042 NEW)
endif()

if(SOPT_MPI)
  include(DetectIntegerArchitecture)
  DetectIntegerArchitecture(SOPT)
endif()

if(tests)
  find_package(Catch2)
  include(AddCatchTest)
endif()

if(examples)
  include(AddExample)
endif()

if(benchmarks)
  set(GBenchmark_GIT_TAG "v1.3.0")
  include(AddBenchmark)
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-command-line-argument")

if(tests AND coverage)
  # Enable code coverage.
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} --coverage")

	# Build with debugging information to make the output meaningful.
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g")

	# Disable optimizations to get the most accurate results.
	set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O0")
endif()

add_subdirectory(cpp)

# Exports all Sopt so other packages can access it
include(export_sopt)

=== cpp/sopt/CMakeLists.txt ===
# list of headers
set(headers
  bisection_method.h chained_operators.h credible_region.h
  imaging_padmm.h logging.h
  forward_backward.h imaging_forward_backward.h
  g_proximal.h l1_g_proximal.h joint_map.h
  imaging_primal_dual.h primal_dual.h
  maths.h proximal.h relative_variation.h sdmm.h
  wavelets.h conjugate_gradient.h l1_proximal.h padmm.h proximal_expression.h
  reweighted.h types.h wrapper.h exception.h linear_transform.h positive_quadrant.h
  tv_primal_dual.h gradient_operator.h
  l2_forward_backward.h l2_primal_dual.h
  real_type.h sampling.h power_method.h objective_functions.h ${PROJECT_BINARY_DIR}/include/sopt/config.h
)

set(wavelet_headers
  wavelets/direct.h wavelets/indirect.h wavelets/innards.impl.h wavelets/sara.h
  wavelets/wavelet_data.h wavelets/wavelets.h
)

set(sources logging.cc wavelets/wavelets.cc wavelets/wavelet_data.cc)

if(TIFF_FOUND)
  list(APPEND sources utilities.cc)
  list(APPEND headers utilities.h)
endif()

if(SOPT_MPI)
  list(APPEND sources mpi/communicator.cc mpi/registered_types.cc mpi/session.cc)
  list(APPEND mpi_headers mpi/communicator.h mpi/registered_types.h mpi/utilities.h mpi/session.h)
endif()

if(onnxrt)
  list(APPEND headers ort_session.h tf_g_proximal.h)
endif()

add_library(sopt SHARED ${sources})
set(version "${SOPT_VERSION_MAJOR}.${SOPT_VERSION_MINOR}.${SOPT_VERSION_PATCH}")
set(soversion "${SOPT_VERSION_MAJOR}.${SOPT_VERSION_MINOR}")
set_target_properties(sopt PROPERTIES VERSION ${version} SOVERSION ${soversion})

target_include_directories(sopt PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/..>
  $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/include>
  $<INSTALL_INTERFACE:include/>)

if(TIFF_FOUND)
  target_link_libraries(sopt TIFF::TIFF)
  target_include_directories(sopt SYSTEM PUBLIC ${TIFF_INCLUDE_DIR})
endif()

if(EIGEN3_INCLUDE_DIR)
  target_include_directories(sopt SYSTEM PUBLIC ${EIGEN3_INCLUDE_DIR})
endif()

if(SOPT_OPENMP)
  target_link_libraries(sopt OpenMP::OpenMP_CXX)
endif()

if(SOPT_MPI)
  target_link_libraries(sopt ${MPI_CXX_LIBRARIES})
  target_include_directories(sopt SYSTEM PUBLIC ${MPI_CXX_INCLUDE_PATH})
endif()

if(onnxrt)
  target_link_libraries(sopt ${onnxruntime_LIBRARIES})
  target_include_directories(sopt SYSTEM PUBLIC ${onnxruntime_INCLUDE_DIR})
endif()

install(FILES ${headers} DESTINATION include/sopt)
install(FILES ${wavelet_headers} DESTINATION include/sopt/wavelets)
install(FILES ${mpi_headers} DESTINATION include/sopt/mpi)
install(TARGETS sopt
  EXPORT soptCPPTargets
  DESTINATION share/cmake/sopt
  LIBRARY DESTINATION lib
  ARCHIVE DESTINATION lib
  INCLUDES DESTINATION include
)

=== cpp/tests/CMakeLists.txt ===
add_library(common_catch_main_object OBJECT "common_catch_main.cc")

if(Catch2_FOUND)
  target_link_libraries(common_catch_main_object Catch2::Catch2)
endif()

if(EIGEN3_INCLUDE_DIR)
  target_include_directories(common_catch_main_object SYSTEM PUBLIC ${EIGEN3_INCLUDE_DIR})
endif()

if(onnxruntime_INCLUDE_DIR)
  target_include_directories(common_catch_main_object SYSTEM PUBLIC ${onnxruntime_INCLUDE_DIR})
endif()

target_include_directories(common_catch_main_object PUBLIC
  "${EXTERNAL_ROOT}/include/"
  "${PROJECT_BINARY_DIR}/include/"
  "${CMAKE_CURRENT_SOURCE_DIR}/.."
)

if(CATCH_HAS_THROWS_AS)
  add_definitions(-DCATCH_HAS_THROWS_AS)
endif()

set(RAND_SEED "1449580491")

add_catch_test(bisection_method LIBRARIES sopt SEED ${RAND_SEED})
add_catch_test(chained_operators LIBRARIES sopt SEED ${RAND_SEED})
add_catch_test(conjugate_gradient LIBRARIES sopt SEED ${RAND_SEED})
add_catch_test(credible_region LIBRARIES sopt SEED ${RAND_SEED})
add_catch_test(forward_backward LIBRARIES sopt tools_for_tests SEED ${RAND_SEED})
add_catch_test(gradient_operator LIBRARIES sopt tools_for_tests SEED ${RAND_SEED})
add_catch_test(inpainting LIBRARIES sopt tools_for_tests SEED ${RAND_SEED})
add_catch_test(linear_transform LIBRARIES sopt SEED ${RAND_SEED})
add_catch_test(maths LIBRARIES sopt SEED ${RAND_SEED})
add_catch_test(padmm LIBRARIES sopt SEED ${RAND_SEED})
add_catch_test(padmm_warm_start LIBRARIES sopt SEED ${RAND_SEED})
add_catch_test(power_method LIBRARIES sopt SEED ${RAND_SEED})
add_catch_test(primal_dual LIBRARIES sopt SEED ${RAND_SEED})
add_catch_test(proximal LIBRARIES sopt SEED ${RAND_SEED})
add_catch_test(reweighted LIBRARIES sopt SEED ${RAND_SEED})
add_catch_test(sara LIBRARIES sopt SEED ${RAND_SEED})
add_catch_test(sdmm LIBRARIES sopt SEED ${RAND_SEED})
add_catch_test(sdmm_warm_start LIBRARIES sopt SEED ${RAND_SEED})
add_catch_test(wavelets LIBRARIES sopt SEED ${RAND_SEED})
add_catch_test(wrapper LIBRARIES sopt SEED ${RAND_SEED})

if(onnxrt)
  add_catch_test(ort_model LIBRARIES sopt ${onnxruntime_LIBRARIES})
  add_catch_test(tf_model LIBRARIES sopt tools_for_tests ${onnxruntime_LIBRARIES})
  add_catch_test(tf_inpainting LIBRARIES sopt tools_for_tests ${onnxruntime_LIBRARIES} SEED ${RAND_SEED})
endif()

install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/test_data DESTINATION .)

if(SOPT_MPI)
  add_library(common_mpi_catch_main_object OBJECT common_mpi_catch_main.cc)

  target_include_directories(common_mpi_catch_main_object
    PUBLIC ${PROJECT_SOURCE_DIR}/cpp ${PROJECT_BINARY_DIR}/include ${MPI_CXX_INCLUDE_PATH})

  if(Catch2_FOUND)
    target_link_libraries(common_mpi_catch_main_object Catch2::Catch2)
  endif()

  if(EIGEN3_INCLUDE_DIR)
    target_include_directories(common_mpi_catch_main_object SYSTEM PUBLIC ${EIGEN3_INCLUDE_DIR})
  endif()

  function(add_mpi_test_from_test testname)
    unset(arguments)
    if(CATCH_JUNIT)
      set(arguments -r junit -o ${PROJECT_BINARY_DIR}/Testing/${testname}.xml)
    endif()
    if(NOT MPIEXEC_MAX_NUMPROCS)
      set(MPIEXEC_MAX_NUMPROCS 4)
    endif()
    add_test(NAME ${testname}
      COMMAND
      ${MPIEXEC} ${MPIEXEC_NUMPROC_FLAG} ${MPIEXEC_MAX_NUMPROCS} ${MPIEXEC_PREFLAGS}
      "./test_${testname}" ${arguments})
    set_tests_properties(${testname} PROPERTIES LABELS "catch;mpi")
  endfunction()

  function(add_mpi_test testname)
    add_catch_test(${testname} COMMON_MAIN common_mpi_catch_main_object NOTEST ${ARGN})
    add_mpi_test_from_test(${testname})
  endfunction()

  add_mpi_test(communicator LIBRARIES sopt)
  add_mpi_test(mpi_proximals LIBRARIES sopt)
  add_mpi_test(serial_vs_parallel_padmm LIBRARIES sopt tools_for_tests)
  add_mpi_test(mpi_wavelets LIBRARIES sopt)

  add_catch_test(mpi_session NOMAIN LIBRARIES sopt NOTEST)
  add_mpi_test_from_test(mpi_session)
endif()

=== cpp/examples/primal_dual/CMakeLists.txt ===
add_example(pd_inpainting inpainting.cc LIBRARIES sopt tools_for_tests LABELS pd)
add_example(pd_tv_inpainting tv_inpainting.cc LIBRARIES sopt tools_for_tests LABELS pd)

=== debian/changelog ===
sopt (4.2.0+dfsg-2) unstable; urgency=medium

  * Replace catch b-dep with catch2 (Closes: #1092263)

 -- Ole Streicher <olebole@debian.org>  Mon, 06 Jan 2025 20:38:00 +0100

sopt (4.2.0+dfsg-1) unstable; urgency=medium

  * New upstream version 4.2.0+dfsg
  * Drop patches that were applied upstream
  * Ignore test data in installation

 -- Ole Streicher <olebole@debian.org>  Fri, 27 Dec 2024 16:18:49 +0100

=== debian/control ===
Source: sopt
Maintainer: Debian Astro Team <debian-astro-maintainers@lists.alioth.debian.org>
Uploaders: Gijs Molenaar <gijs@pythonic.nl>,
           Ole Streicher <olebole@debian.org>
Section: science
Priority: optional
Build-Depends: dpkg-dev (>= 1.22.5),
               catch2,
               cmake,
               debhelper-compat (= 13),
               libblas-dev,
               libeigen3-dev,
               libspdlog-dev,
               libtiff5-dev,
               mpi-default-dev
Standards-Version: 4.7.0
Vcs-Browser: https://salsa.debian.org/debian-astro-team/sopt
Vcs-Git: https://salsa.debian.org/debian-astro-team/sopt.git
Homepage: https://astro-informatics.github.io/sopt/
Rules-Requires-Root: no

Package: libsopt3.0t64
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Breaks: libsopt3.0 (<< ${source:Version})
Provides: ${t64:Provides}
Replaces: libsopt3.0
Description: Sparse OPTimisation shared library
 SOPT is a C package to perform Sparse OPTimisation.  It solves a
 variety of sparse regularisation problems, including the SARA
 algorithm.
 .
 SOPT is largely provided to support the PURIFY package, a companion
 open-source code to perform radio interferometric imaging, also
 written by the authors of SOPT.
 .
 This package contains the shared library.

Package: libsopt-dev
Architecture: any
Section: libdevel
Depends: mpi-default-dev,
         libsopt3.0t64 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Development package for Sparse OPTimisation library
 SOPT is a C package to perform Sparse OPTimisation.  It solves a
 variety of sparse regularisation problems, including the SARA
 algorithm.
 .
 SOPT is largely provided to support the PURIFY package, a companion
 open-source code to perform radio interferometric imaging, also
 written by the authors of SOPT.
 .
 This package contains the development files.

## sopt 5.0.1%2Bdfsg

=== debian/changelog ===
sopt (5.0.1+dfsg-1) unstable; urgency=medium

  * New upstream version 5.0.1+dfsg
  * Switch back to unstable to start transition
  * Rediff patches

 -- Ole Streicher <olebole@debian.org>  Mon, 29 Sep 2025 12:53:55 +0200

sopt (5.0.0+dfsg-1) experimental; urgency=medium

  * New upstream version 5.0.0+dfsg (Closes: #1113528)
  * Rediff patches
  * Change SOVERSION to 5.0
  * Switch to experimental to prepare transition.
  * Remove obsolete 'Name' from d/u/metadata
  * Push Standards-Version to 4.7.2, no changes needed
  * Build-Depends: libtiff5-dev => libtiff-dev
  * d/watch: update to format version 5.0
  * d/copyright: remove outdated paragraph

 -- Ole Streicher <olebole@debian.org>  Mon, 29 Sep 2025 11:06:21 +0200

## sopt 5.0.1+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -33,7 +33,7 @@
 find_package(Git)
 
 # Set version variable
-set(SOPT_VERSION 3.1.0)
+set(SOPT_VERSION 5.0.0)
 
 # If git is found and this is a git workdir, then figure out build id
 # Stores results in SOPT_VERSION and SOPT_GITREF
@@ -102,11 +102,6 @@
   include(AddExample)
 endif()
 
-if(benchmarks)
-  set(GBenchmark_GIT_TAG "v1.3.0")
-  include(AddBenchmark)
-endif()
-
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-command-line-argument")
 
 if(tests AND coverage)

=== cpp/CMakeLists.txt ===

set(version ${SOPT_VERSION})
string(REGEX REPLACE "\\." ";" version "${SOPT_VERSION}")
list(GET version 0 SOPT_VERSION_MAJOR)
list(GET version 1 SOPT_VERSION_MINOR)
list(GET version 2 SOPT_VERSION_PATCH)

configure_file(sopt/config.in.h "${PROJECT_BINARY_DIR}/include/sopt/config.h")

add_subdirectory(sopt)
if(examples OR tests)
  # Tiff wrappers and whatnot
  add_subdirectory(tools_for_tests)
endif()
if(tests)
  add_subdirectory(tests)
endif()
if(examples)
  add_subdirectory(examples)
endif()
if(benchmarks)
  add_subdirectory(benchmarks)
endif()
if (docs)
  add_subdirectory(docs)
endif()

=== cpp/benchmarks/CMakeLists.txt ===
add_executable(wavelets wavelets.cc)
target_link_libraries(wavelets benchmark sopt)
add_executable(conjugate_gradient conjugate_gradient.cc)
target_link_libraries(conjugate_gradient benchmark sopt)
add_executable(l1_proximal l1_proximal.cc)
target_link_libraries(l1_proximal benchmark sopt)

=== cpp/docs/CMakeLists.txt ===
# Set some Doxygen flags
set(SOPT_DOXY_PROJECT_NAME "SOPT")
set(SOPT_DOXY_PROJECT_BRIEF "Sparse OPTimisation")
set(SOPT_DOXY_INPUT "${PROJECT_SOURCE_DIR}/cpp")

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
  ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
)

file(COPY
  ${CMAKE_CURRENT_SOURCE_DIR}/DoxygenLayout.xml
  DESTINATION ${CMAKE_CURRENT_BINARY_DIR}
)


add_custom_target(doc ALL
  COMMAND doxygen
  WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})


# This will create a target in the Makefile that's used to push docs to github.io
if(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
  add_custom_target(docweb
    COMMAND sed -i '' -e 's@namespacesopt@http://astro-informatics.github.io/sopt/&@g' -e 's@<filename>@&http://astro-informatics.github.io/sopt/@g' ${CMAKE_CURRENT_BINARY_DIR}/html/sopt.tag
    DEPENDS doc)
else()
  add_custom_target(docweb
    COMMAND sed -i -e 's@namespacesopt@http://astro-informatics.github.io/sopt/&@g' -e 's@<filename>@&http://astro-informatics.github.io/sopt/@g' ${CMAKE_CURRENT_BINARY_DIR}/html/sopt.tag
    DEPENDS doc)
endif()

=== cpp/examples/CMakeLists.txt ===
add_example(conjugate_gradient LIBRARIES sopt)
add_example(l1_norm LIBRARIES sopt LABELS proximals)
add_example(l1_proximal LIBRARIES sopt)
add_example(positive_quadrant_projection LIBRARIES sopt LABELS proximals)
add_example(power_method LIBRARIES sopt)
add_example(sara LIBRARIES sopt LABELS wavelets)
add_example(soft_threshhold LIBRARIES sopt LABELS proximals)
add_example(wavelets LIBRARIES sopt LABELS wavelets)

add_subdirectory(forward_backward)
add_subdirectory(primal_dual)
add_subdirectory(proximal_admm)
add_subdirectory(sdmm)

=== cpp/sopt/CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,8 @@
   bisection_method.h chained_operators.h credible_region.h
   imaging_padmm.h logging.h
   forward_backward.h imaging_forward_backward.h
-  g_proximal.h l1_g_proximal.h joint_map.h
+  non_differentiable_func.h l1_non_diff_function.h real_indicator.h joint_map.h
+  differentiable_func.h l2_differentiable_func.h gradient_utils.h
   imaging_primal_dual.h primal_dual.h
   maths.h proximal.h relative_variation.h sdmm.h
   wavelets.h conjugate_gradient.h l1_proximal.h padmm.h proximal_expression.h
@@ -11,7 +12,7 @@
   tv_primal_dual.h gradient_operator.h
   l2_forward_backward.h l2_primal_dual.h
   real_type.h sampling.h power_method.h objective_functions.h ${PROJECT_BINARY_DIR}/include/sopt/config.h
-)
+  )
 
 set(wavelet_headers
   wavelets/direct.h wavelets/indirect.h wavelets/innards.impl.h wavelets/sara.h
@@ -31,7 +32,9 @@
 endif()
 
 if(onnxrt)
-  list(APPEND headers ort_session.h tf_g_proximal.h)
+
+  list(APPEND headers ort_session.h onnx_differentiable_func.h tf_non_diff_function.h)
+
 endif()
 
 add_library(sopt SHARED ${sources})
@@ -52,6 +55,7 @@
 if(EIGEN3_INCLUDE_DIR)
   target_include_directories(sopt SYSTEM PUBLIC ${EIGEN3_INCLUDE_DIR})
 endif()
+message(STATUS "Eigen3 include dir ${EIGEN3_INCLUDE_DIR}")
 
 if(SOPT_OPENMP)
   target_link_libraries(sopt OpenMP::OpenMP_CXX)
@@ -63,8 +67,14 @@
 endif()
 
 if(onnxrt)
+  if(${onnxruntime_FOUND})
+    message(STATUS "ONNX Source dir ${onnxruntime_SOURCE_DIR}")
+    message(STATUS "ONNX Include dir ${onnxruntime_INCLUDE_DIR}")
+  endif()
   target_link_libraries(sopt ${onnxruntime_LIBRARIES})
   target_include_directories(sopt SYSTEM PUBLIC ${onnxruntime_INCLUDE_DIR})
+else()
+  message(STATUS "ONNXrt not found. ONNXrt support disabled.")
 endif()
 
 install(FILES ${headers} DESTINATION include/sopt)

=== cpp/tests/CMakeLists.txt ===
--- 
+++ 
@@ -31,6 +31,8 @@
 add_catch_test(forward_backward LIBRARIES sopt tools_for_tests SEED ${RAND_SEED})
 add_catch_test(gradient_operator LIBRARIES sopt tools_for_tests SEED ${RAND_SEED})
 add_catch_test(inpainting LIBRARIES sopt tools_for_tests SEED ${RAND_SEED})
+add_catch_test(stochastic_update LIBRARIES sopt tools_for_tests SEED ${RAND_SEED})
+add_catch_test(pd_inpainting LIBRARIES sopt tools_for_tests SEED ${RAND_SEED})
 add_catch_test(linear_transform LIBRARIES sopt SEED ${RAND_SEED})
 add_catch_test(maths LIBRARIES sopt SEED ${RAND_SEED})
 add_catch_test(padmm LIBRARIES sopt SEED ${RAND_SEED})
@@ -49,6 +51,7 @@
   add_catch_test(ort_model LIBRARIES sopt ${onnxruntime_LIBRARIES})
   add_catch_test(tf_model LIBRARIES sopt tools_for_tests ${onnxruntime_LIBRARIES})
   add_catch_test(tf_inpainting LIBRARIES sopt tools_for_tests ${onnxruntime_LIBRARIES} SEED ${RAND_SEED})
+  add_catch_test(onnx_inpainting LIBRARIES sopt tools_for_tests ${onnxruntime_LIBRARIES} SEED ${RAND_SEED})
 endif()
 
 install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/test_data DESTINATION .)

=== cpp/tools_for_tests/CMakeLists.txt ===
add_library(tools_for_tests STATIC tiffwrappers.cc tiffwrappers.h)
target_link_libraries(tools_for_tests TIFF::TIFF)
target_link_libraries(tools_for_tests sopt)
target_include_directories(tools_for_tests PUBLIC
  "${CMAKE_CURRENT_SOURCE_DIR}/.."
  "${PROJECT_BINARY_DIR}/include/"
)
target_include_directories(tools_for_tests SYSTEM PUBLIC ${TIFF_INCLUDE_DIR})
if(EIGEN3_INCLUDE_DIR)
  target_include_directories(tools_for_tests SYSTEM PUBLIC ${EIGEN3_INCLUDE_DIR})
endif()


# Simple manual tester of read/write tiff
add_executable(copy_tiff copy_tiff.cc)
target_link_libraries(copy_tiff tools_for_tests sopt)

configure_file("directories.in.h" "${PROJECT_BINARY_DIR}/include/tools_for_tests/directories.h")

install(FILES "${PROJECT_BINARY_DIR}/include/tools_for_tests/directories.h" DESTINATION include/sopt)
#file(MAKE_DIRECTORY "${PROJECT_BINARY_DIR}/outputs")
#file(MAKE_DIRECTORY "${PROJECT_BINARY_DIR}/outputs/sdmm")

=== cpp/examples/forward_backward/CMakeLists.txt ===
add_example(forward_backward_inpainting inpainting.cc LIBRARIES sopt tools_for_tests)
add_example(forward_backward_l2_inpainting l2_inpainting.cc LIBRARIES sopt tools_for_tests)
add_example(forward_backward_inpainting_joint_map inpainting_joint_map.cc LIBRARIES sopt tools_for_tests)
add_example(forward_backward_inpainting_credible_interval inpainting_credible_interval.cc LIBRARIES sopt tools_for_tests NOTEST)

=== cpp/examples/proximal_admm/CMakeLists.txt ===
add_example(padmm_euclidian_norm euclidian_norm.cc LIBRARIES sopt LABELS padmm)
add_example(padmm_inpainting inpainting.cc LIBRARIES sopt tools_for_tests)
add_example(padmm_reweighted NOTEST reweighted.cc LIBRARIES sopt tools_for_tests)

=== cpp/examples/sdmm/CMakeLists.txt ===
add_example(euclidian_norm LIBRARIES sopt LABELS sdmm)
add_example(inpainting LIBRARIES sopt tools_for_tests LABELS sdmm)
add_example(reweighted NOTEST LIBRARIES sopt tools_for_tests LABELS sdmm)

=== debian/control ===
--- 
+++ 
@@ -11,23 +11,20 @@
                libblas-dev,
                libeigen3-dev,
                libspdlog-dev,
-               libtiff5-dev,
+               libtiff-dev,
                mpi-default-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debian-astro-team/sopt
 Vcs-Git: https://salsa.debian.org/debian-astro-team/sopt.git
 Homepage: https://astro-informatics.github.io/sopt/
 Rules-Requires-Root: no
 
-Package: libsopt3.0t64
+Package: libsopt5.0
 Architecture: any
 Multi-Arch: same
 Section: libs
 Depends: ${misc:Depends},
          ${shlibs:Depends}
-Breaks: libsopt3.0 (<< ${source:Version})
-Provides: ${t64:Provides}
-Replaces: libsopt3.0
 Description: Sparse OPTimisation shared library
  SOPT is a C package to perform Sparse OPTimisation.  It solves a
  variety of sparse regularisation problems, including the SARA
@@ -43,7 +40,7 @@
 Architecture: any
 Section: libdevel
 Depends: mpi-default-dev,
-         libsopt3.0t64 (= ${binary:Version}),
+         libsopt5.0 (= ${binary:Version}),
          ${misc:Depends},
          ${shlibs:Depends}
 Description: Development package for Sparse OPTimisation library

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

CMAKE_FLAGS += -DDEB_HOST_MULTIARCH=`dpkg-architecture -qDEB_HOST_MULTIARCH`

export DEB_CXXFLAGS_MAINT_APPEND += -DFMT_DEPRECATED_OSTREAM

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)

=== debian/watch ===
Version: 5
Template: Github
Owner: astro-informatics
Project: sopt
Repacksuffix: +dfsg
